% ressort07.m
% fd  6 avril 2005, 08 janvier 2006, 09, 10 mars, 13 mai 2006 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
title ('precision du Newmark dans le cas non amorti') ;
mm1 = 1 ; mm2 = 1 ; mm3 = 1 ;  kk1 = 1 ; kk2 = 2 ; 
mm=[ mm1 0 0 ; 0  mm2 0 ; 0 0  mm3 ]  ; 
cc=[ 0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
kk=[ kk1 -kk1 0 ; -kk1 kk1+kk2 -kk2 ; 0 -kk2 kk2 ] ; 
x0 = [ 1 -1  0 ]' ;
y0 = [ 0 0 1 ]' ;
tmax= 10 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution analytique     %%%%%%%%%%%%
z3 = [  0  0 0 ; 0  0  0 ; 0 0  0 ] ; 
I3 = [  1  0 0 ; 0  1  0 ; 0 0  1 ] ; 
aa = [ z3 , I3 ; -mm\kk , z3  ] ;  
u0 = [ x0 ; y0 ] ; 
uf = expm(tmax*aa)*u0 ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
m=6
pas=zeros(m,1);
err=zeros(m,1);
%
n=32

for j=1:m;
dt=tmax/n ; 
t=zeros(1,n+1);
x=zeros(3,n+1);
y=zeros(3,n+1); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       solution numerique     %%%%%%%%%%%%
xx = x0 ;
yy = y0 ;
ga = -mm \ (cc * yy + kk*xx)  ;
ss = mm + .5*dt*cc + .25*dt*dt*kk ; 
for i=1:n;
t(i+1)=t(i)+dt;
end ; 
for i=1:n;
xt = xx + dt*yy + .25*dt*dt*ga ; 
yt = yy + .5*dt * ga ; 
ga = ss \ ( - kk*xt - cc*yt ) ;
xn = xt + .25*dt*dt*ga ; 
yn = yt + .5*dt*ga ; 
%
x(:,i+1:i+1) = xn(:,1) ; 
y(:,i+1:i+1) = yn(:,1) ; 
xx(:,1) = x(:,i+1:i+1) ; 
yy(:,1) = y(:,i+1:i+1) ; 
end ;
xmax=tmax+.1 ; 
axis ( [ -.1   , xmax  , -10.1 , 10.1 ]) ;
plot(t(1,:) , x(1:1,:), '*;;' , t(1,:) , x(2:2,:), '*b;;'  , \
 t(1,:) , x(3:3,:), '*g;;' ,  t(1,:) , mm1*x(1:1,:) + mm2*x(2:2,:) + mm3*x(3:3,:) , '*m;;' ) ; 
pause  

%                       erreur
pas(j:j,1)=n ; 
err(j:j,1)=log ( abs( x(1:1,n+1:n+1) - uf(1:1,1) ) + \ 
 abs( x(2:2,n+1:n+1) - uf(2:2,1) ) +  abs( x(3:3,n+1:n+1) - uf(3:3,1) )  ) / log(2)  ;
n=2*n;
end 



x=zeros(m,1); x =log(pas(:,1)) / log(2) ;
y=zeros(m,1); y= err(:,1) ;
toto=0
     xmax= m+4 +.1 ; 
axis ([ 4.9 ,  xmax  ,  -15.1 , .1 ]) ;
plot( x , y ,'*;logarithme des ereurs;') ;
%
%               droite des moindres carres
xm=0;
ym=0;
x2m=0;
y2m=0;
xym=0;
  for j=1:m;
xm=xm+x(j);
ym=ym+y(j);
x2m=x2m+x(j)*x(j);
y2m=y2m+y(j)*y(j);
xym=xym+x(j)*y(j);
end ;
xm=xm / m ;
ym=ym / m ;
x2m=x2m / m ;
y2m=y2m / m ;
xym=xym / m ;
alfa = ( xym -xm*ym ) / (x2m - xm*xm )








